(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var ECMAScript = Package.ecmascript.ECMAScript;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var Accounts = Package['accounts-base'].Accounts;
var AccountsServer = Package['accounts-base'].AccountsServer;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var EmailInternals = Package.email.EmailInternals;
var babelHelpers = Package['babel-runtime'].babelHelpers;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var Promise = Package.promise.Promise;
var Iron = Package['iron:core'].Iron;

(function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_common.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
Accounts.emailToken = {};                                                                                        // 1
                                                                                                                 //
Accounts.emailToken._hashToken = function (token) {                                                              // 3
  return {                                                                                                       // 4
    digest: SHA256(token),                                                                                       // 5
    algorithm: "sha-256"                                                                                         // 6
  };                                                                                                             //
};                                                                                                               //
                                                                                                                 //
Router.route("/_emailLogin/:_email/:_token", function () {                                                       // 10
  var _this = this;                                                                                              //
                                                                                                                 //
  this.render("Loading");                                                                                        // 11
  Meteor.loginWithEmailToken(this.params._email, this.params._token, function (err) {                            // 12
    if (err) {                                                                                                   // 13
      _this.render("_emailTokenError", {                                                                         // 14
        data: function () {                                                                                      // 15
          return {                                                                                               // 16
            error: err                                                                                           // 17
          };                                                                                                     //
        }                                                                                                        //
      });                                                                                                        //
    } else {                                                                                                     //
      Router.go("/");                                                                                            // 22
    }                                                                                                            //
  });                                                                                                            //
});                                                                                                              //
                                                                                                                 //
Router.route("/_emailLinkIdentity/:_email/:_token/:_accountId", function () {                                    // 27
  var _this2 = this;                                                                                             //
                                                                                                                 //
  this.render("Loading");                                                                                        // 28
  if (this.state.get("error")) {                                                                                 // 29
    this.render("_emailLinkIdentityError", { data: { error: this.state.get("error") } });                        // 30
  } else {                                                                                                       //
    if (Meteor.userId() === this.params._accountId) {                                                            // 32
      Meteor.call("linkEmailIdentityToAccount", this.params._email, this.params._token, function (err, result) {
        if (err) {                                                                                               // 35
          _this2.state.set("error", err.toString());                                                             // 36
        } else {                                                                                                 //
          Router.go("/account");                                                                                 // 38
        }                                                                                                        //
      });                                                                                                        //
    } else {                                                                                                     //
      this.render("_emailLinkIdentityError");                                                                    // 42
    }                                                                                                            //
  }                                                                                                              //
});                                                                                                              //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_server.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                        // 1
                                                                                                                 //
var cleanupExpiredTokens = function () {                                                                         // 3
  Meteor.users.update({                                                                                          // 4
    "services.email.tokens.createdAt": {                                                                         // 5
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                            // 6
    }                                                                                                            //
  }, {                                                                                                           //
    $pull: {                                                                                                     // 9
      "services.email.tokens": {                                                                                 // 10
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                           // 11
      }                                                                                                          //
    }                                                                                                            //
  }, {                                                                                                           //
    multi: true                                                                                                  // 15
  });                                                                                                            //
};                                                                                                               //
                                                                                                                 //
Meteor.startup(cleanupExpiredTokens);                                                                            // 19
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                        //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                          // 21
                                                                                                                 //
var checkToken = function (tokens, token) {                                                                      // 23
  var found = false;                                                                                             // 24
  tokens.forEach(function (userToken) {                                                                          // 25
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                          // 26
      found = true;                                                                                              // 28
    }                                                                                                            //
  });                                                                                                            //
                                                                                                                 //
  return found;                                                                                                  // 32
};                                                                                                               //
                                                                                                                 //
// The name of the email package to use. It refers to a variable named in the global scope.                      //
var EMAIL_PACKAGE = "Email";                                                                                     // 36
                                                                                                                 //
Accounts.emailToken.setEmailPackage = function (packageName) {                                                   // 38
  EMAIL_PACKAGE = packageName;                                                                                   // 39
};                                                                                                               //
                                                                                                                 //
function consumeToken(user, token) {                                                                             // 42
  var hashedToken = Accounts.emailToken._hashToken(token);                                                       // 43
  var found = checkToken(user.services.email.tokens, hashedToken);                                               // 44
                                                                                                                 //
  if (found) {                                                                                                   // 46
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                 // 47
  }                                                                                                              //
                                                                                                                 //
  return found;                                                                                                  // 50
}                                                                                                                //
                                                                                                                 //
// Handler to login with a token.                                                                                //
Accounts.registerLoginHandler("email", function (options) {                                                      // 54
  if (!options.email) {                                                                                          // 55
    return undefined; // don't handle                                                                            // 56
  }                                                                                                              //
                                                                                                                 //
  if (!Accounts.identityServices.email.isEnabled()) {                                                            // 59
    throw new Meteor.Error(403, "Email identity service is disabled.");                                          // 60
  }                                                                                                              //
                                                                                                                 //
  options = options.email;                                                                                       // 63
  check(options, {                                                                                               // 64
    email: String,                                                                                               // 65
    token: String                                                                                                // 66
  });                                                                                                            //
                                                                                                                 //
  var user = Meteor.users.findOne({                                                                              // 69
    "services.email.email": options.email                                                                        // 70
  }, {                                                                                                           //
    fields: {                                                                                                    // 72
      "services.email": 1                                                                                        // 73
    }                                                                                                            //
  });                                                                                                            //
                                                                                                                 //
  if (!user) {                                                                                                   // 77
    console.error("User not found:", options.email);                                                             // 78
    return {                                                                                                     // 79
      error: new Meteor.Error(403, "User not found")                                                             // 80
    };                                                                                                           //
  }                                                                                                              //
                                                                                                                 //
  if (!user.services.email.tokens) {                                                                             // 84
    console.error("User has no token set:", options.email);                                                      // 85
    return {                                                                                                     // 86
      error: new Meteor.Error(403, "User has no token set")                                                      // 87
    };                                                                                                           //
  }                                                                                                              //
                                                                                                                 //
  if (!consumeToken(user, options.token.trim())) {                                                               // 91
    console.error("Token not found:", options.email);                                                            // 92
    return {                                                                                                     // 93
      error: new Meteor.Error(403, "Invalid authentication code")                                                // 94
    };                                                                                                           //
  }                                                                                                              //
                                                                                                                 //
  return {                                                                                                       // 98
    userId: user._id                                                                                             // 99
  };                                                                                                             //
});                                                                                                              //
                                                                                                                 //
var Url = Npm.require("url");                                                                                    // 103
                                                                                                                 //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                  // 105
var HOSTNAME = ROOT_URL.hostname;                                                                                // 106
                                                                                                                 //
var makeTokenUrl = function (email, token, linkingIdentity) {                                                    // 108
  if (linkingIdentity) {                                                                                         // 109
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                       //
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);
  }                                                                                                              //
};                                                                                                               //
                                                                                                                 //
///                                                                                                              //
/// EMAIL VERIFICATION                                                                                           //
///                                                                                                              //
var sendTokenEmail = function (db, email, token, linkingIdentity) {                                              // 121
  var subject = undefined;                                                                                       // 122
  var text = undefined;                                                                                          // 123
  if (!linkingIdentity) {                                                                                        // 124
    subject = "Log in to " + HOSTNAME;                                                                           // 125
    text = "To confirm this email address on ";                                                                  // 126
  } else {                                                                                                       //
    subject = "Confirm this email address on " + HOSTNAME;                                                       // 128
    text = "To confirm this email address on ";                                                                  // 129
  }                                                                                                              //
                                                                                                                 //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                 //
  var options = {                                                                                                // 137
    to: email,                                                                                                   // 138
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                              // 139
    subject: subject,                                                                                            // 140
    text: text                                                                                                   // 141
  };                                                                                                             //
                                                                                                                 //
  global[EMAIL_PACKAGE].send(options);                                                                           // 144
};                                                                                                               //
                                                                                                                 //
///                                                                                                              //
/// CREATING USERS                                                                                               //
///                                                                                                              //
// returns the user id                                                                                           //
var createAndEmailTokenForUser = function (db, email, linkingIdentity) {                                         // 151
  check(email, String);                                                                                          // 152
  check(linkingIdentity, Boolean);                                                                               // 153
  var atIndex = email.indexOf("@");                                                                              // 154
  if (atIndex === -1) {                                                                                          // 155
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                          // 156
  }                                                                                                              //
                                                                                                                 //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 159
  var userId = undefined;                                                                                        // 161
                                                                                                                 //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                           //
  var token = Random.id(12);                                                                                     // 164
  var tokenObj = Accounts.emailToken._hashToken(token);                                                          // 165
  tokenObj.createdAt = new Date();                                                                               // 166
                                                                                                                 //
  if (user) {                                                                                                    // 168
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                   // 169
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                            //
                                                                                                                 //
    userId = user._id;                                                                                           // 175
                                                                                                                 //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                    // 177
  } else {                                                                                                       //
    var options = {};                                                                                            // 179
    user = {                                                                                                     // 180
      services: {                                                                                                // 181
        email: {                                                                                                 // 182
          tokens: [tokenObj],                                                                                    // 183
          email: email                                                                                           // 184
        }                                                                                                        //
      }                                                                                                          //
    };                                                                                                           //
                                                                                                                 //
    userId = Accounts.insertUserDoc(options, user);                                                              // 189
  }                                                                                                              //
                                                                                                                 //
  sendTokenEmail(db, email, token, linkingIdentity);                                                             // 192
                                                                                                                 //
  return userId;                                                                                                 // 194
};                                                                                                               //
                                                                                                                 //
Meteor.methods({                                                                                                 // 197
  createAndEmailTokenForUser: function (email, linkingIdentity) {                                                // 198
    // method for create user. Requests come from the client.                                                    //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                   //
    // It will always send an email to the user                                                                  //
                                                                                                                 //
    check(email, String);                                                                                        // 203
    check(linkingIdentity, Boolean);                                                                             // 204
                                                                                                                 //
    if (!Accounts.identityServices.email.isEnabled()) {                                                          // 206
      throw new Meteor.Error(403, "Email identity service is disabled.");                                        // 207
    }                                                                                                            //
    // Create user. result contains id and token.                                                                //
    var user = createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity);                  // 210
  },                                                                                                             //
                                                                                                                 //
  linkEmailIdentityToAccount: function (email, token) {                                                          // 213
    // Links the email identity with address `email` and login token `token` to the current account.             //
    check(email, String);                                                                                        // 215
    check(token, String);                                                                                        // 216
    var account = Meteor.user();                                                                                 // 217
    if (!account || !account.loginIdentities) {                                                                  // 218
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                 // 219
    }                                                                                                            //
                                                                                                                 //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });
    if (!identity) {                                                                                             // 224
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 225
    }                                                                                                            //
                                                                                                                 //
    if (!consumeToken(identity, token)) {                                                                        // 228
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 229
    }                                                                                                            //
                                                                                                                 //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
  }                                                                                                              //
});                                                                                                              //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
